/* 

passlogd - passive syslog capture daemon
copyright (c) 2001 - christian void <cvoid@morphine.com>

file: util.c

history: 

04jun01 cvoid: added reverse_lookup().
03jun01 cvoid: created.

*/

#include "passlog.h"
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>

/* INIT_BUF */
void init_buf(char x[], int size) 
{
  register int n;

  for(n = 0; n < size; n++)
    {
      x[n] = '\0';
    } 
}

/* FIND_HEADER_LENGTH */
int find_header_length(int d)
{
  switch(d)
    {
    case DLT_NULL:
      return(4);		/* loopback header 4 bytes */
      break;
    case DLT_EN10MB:
      return(14);		/* ethernet 10mb header 14 bytes */
      break;
    case DLT_FDDI:
      return(21);		/* fddi header 21 bytes */
      break;
    case DLT_PPP:
      return(0);		/* ppp header 0 or 24 bytes? */
      break;
    default:
      return(14);		/* ethernet 10mb header 14 bytes */
      break;
    }
}

int reverse_lookup(char * addrstr)
{
  /* do reverse lookup */
  struct hostent	*hostname, *hostaddr;

  /* resolve the src and destination addresses */
  hostaddr = gethostbyname(addrstr);
  hostname = gethostbyaddr(hostaddr->h_addr, 4, AF_INET);
  
  if(!hostname){
    return 1;
  }
  else {
    strncpy(addrstr, hostname->h_name, strlen(hostname->h_name));
    return 0;
  }
}
