/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _SNIFF_GUI_MAIN_H
#define _SNIFF_GUI_MAIN_H

#include <ncurses.h>
#include "list.h"
#include "gui.h"

#define GUI_OFFSET_PAGE 8 /* how much to jump for page up/down keys */
#define COLOR_NORMAL 1
#define COLOR_TITLE 2

extern pthread_mutex_t gui_mutex;
extern int gui_ready;

extern struct gui_t *gui;

extern struct gui_menu_t gui_menu_main[];
extern struct gui_menu_t gui_menu_ipv4[];

extern void *gui_main(void *arg);
extern void gui_ipv4(struct gui_t *p, int y, int x);
extern void gui_stats(struct gui_t *p, int y, int x);


#endif
