/*

  This file is part of sniffer, a packet capture utility and
  network moniter
  The author can be contacted at <mistral@stev.org>
  the lastest version is avilable from 
  http://stev.org

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _SNIFF_UDP_H
#define _SNIFF_UDP_H


#include "ip.h"
#include "list.h"
#include "stat.h"
#include "gui_main.h"

struct pkt_udp {
	unsigned short	source;
	unsigned short	dest;
	unsigned short	len;
	unsigned short	check;
};


struct udp_conn {
	int delme;					/* used to delete when it reachs 0 kill it */
	unsigned long saddr;
	char *saddr_str;
	char *saddr_name;
	unsigned long daddr;
	char *daddr_str;
	char *daddr_name;
	unsigned short sport;
	unsigned short dport;
	struct gen_stat stat_in;	/* the stats on this direction */
	struct gen_stat stat_out;
};

extern pthread_mutex_t udp_mutex;
extern struct gen_stat udp_stat;

extern WINDOW *udp_gui_window;
extern pthread_mutex_t udp_gui_mutex;

extern struct list_t *udp_slist;
extern pthread_mutex_t udp_mutex_slist;

extern int udp_handle		(struct pkt_ip *ip , struct pkt_udp *udp );
extern int udp_cmp			(struct udp_conn *c1, struct udp_conn *c2);
extern int udp_dump_all		(struct pkt_ip *ip , struct pkt_udp *udp , char *data , unsigned short data_len );
extern inline unsigned short udp_check(struct pkt_udp *th, unsigned short len, unsigned long saddr, unsigned long daddr);
extern void udp_gui_conn	(struct gui_t *p, int y, int x);
extern void udp_gui			(struct gui_t *p, int y, int x);
extern int udp_gui_print	(struct pkt_ip *ip, struct pkt_udp *udp, unsigned short length);
extern int udp_tidy ( void );
extern int udp_init ( void );

#endif /* _SNIFF_UDP_H */


