#ifndef __SP_RPC_CHECK_H__
#define __SP_RPC_CHECK_H__

#include "snort.h"
#include <rpc/types.h>
#include <rpc/xdr.h>
#include <rpc/auth.h>
#include <rpc/clnt.h>
#include <rpc/rpc_msg.h>
#include <netinet/in.h>


#define PLUGIN_RPC_CHECK  14

typedef struct _RpcCheckData
{
   u_long program; /* RPC program number */
   u_long vers; /* RPC program version */
   u_long proc; /* RPC procedure number */
   int flags; /* Which of the above fields have been specified */

} RpcCheckData;

#define RPC_CHECK_PROG 1
#define RPC_CHECK_VERS 2
#define RPC_CHECK_PROC 4

void RpcCheckInit(char *, OptTreeNode *, int);
void SetupRpcCheck();
void ParseRpc(char *, OptTreeNode *);
int CheckRpc(Packet *, struct _OptTreeNode *, OptFpList *);

#endif  /* __SP_RPC_CHECK_H__ */
